<?php
/*

FrontendSimpleEdit Connector

Andchir

OnWebPagePrerender

*/

$lang = $modx->getOption('lang',$scriptProperties,$modx->config['manager_language']);
$usergroups = $modx->getOption('usergroups',$scriptProperties,'');
$content_fields = $modx->getOption('content_fields',$scriptProperties,'{}');
$tv_fields = $modx->getOption('tv_fields',$scriptProperties,'{}');
if(!$content_fields) $content_fields = '{}';
if(!$tv_fields) $tv_fields = '{}';

$resource = $modx->resource;//$modx->getObject('modResource',$modx->resourceIdentifier);

$isEditor = false;

if($modx->user->get('id') && $modx->user->hasSessionContext('mgr')){
    
    //Проверка прав доступа
    if ($modx->hasPermission('save_document') && $resource->checkPolicy('save')) {
        
        //Если нужно проверяем входит ли пользователь в группы
        $isEditor = $usergroups ? $modx->user->isMember(explode(',',str_replace(', ',',',$usergroups))) : true;
        
    }
    
}

if($isEditor){
    
    $modAuth = $modx->user->getUserToken('mgr');
    
    $scriptHtml = '
    <script type="text/javascript" src="/assets/components/frontend_simple_edit/js/frontend_simple_edit.js"></script>
    <script type="text/javascript">
    var feSimpleEditOptions = {
        url: "/assets/components/frontend_simple_edit/connector.php",
        HTTP_MODAUTH: "' . $modAuth . '",
        lang: "' . $modx->getOption('manager_language') . '",
        object_id: ' . $modx->resource->id . ',
        context_key: "' . $modx->context->key . '"
    };
    $(document).bind("ready",function(){
        $("*[data-fedit]").FrontendSimpleEdit(feSimpleEditOptions);
    });
    </script>
    ';
    
    //не кэшируется
    $modx->resource->_output = preg_replace("/(<\/body>)/i", $scriptHtml . "\n\\1", $modx->resource->_output);
    
}


