
/*

FrontendSimpleEdit for MODX Revolution

Andchir
http://wdevblog.net.ru/
http://modx-shopkeeper.ru/

//Example:
$(document).bind('ready',function(){
    $("*[data-fedit]").FrontendSimpleEdit({url:'/assets/components/frontend_simple_edit/connector.php'});
});

*/

(function ( $ ) {
    
    $.FrontendSimpleEdit = {
        
        timer: null,
        opts: {
            lang: 'en',
            action_url: '',
            object_id: 0,
            context_key: 'web',
            HTTP_MODAUTH: ''
        },
        lang_lexicon: {
            ru: {
                button_save: 'Сохранить',
                edit_label: '[р]',
                edit_hint: 'редактировать'
            },
            en: {
                button_save: 'Save',
                edit_label: '[e]',
                edit_hint: 'edit'
            }
        },
        
        editorTemplate: '<div id="frontendEditor" style="display:none; width:300px; padding:5px; background-color:#B8C4D8; position:absolute; z-index:1000;">'
        + '<div class="caret1" style="display:none; border-left: 8px solid rgba(184, 196, 216, 0); border-right: 8px solid rgba(184, 196, 216, 0); border-bottom: 8px solid #B8C4D8; width: 0; height: 0; position:absolute; left:50%; top:-8px; margin-left:-4px;"></div>'
        + '<div style="padding:5px; background-color:#fff; margin-bottom:5px;">'
        + '<textarea style="width:100%; height:16px; padding:0; border:0; resize:vertical; background-color:#fff; font-size:14px;"></textarea>'
        + '</div>'
        + '<button style="width:100%; height:auto; padding:5px 0; background-color:#E6EAF2; color:#000; border:0; cursor:pointer;">Save</button>'
        + '<div class="caret2" style="display: block; border-left: 8px solid rgba(184, 196, 216, 0); border-right: 8px solid rgba(184, 196, 216, 0); border-top: 8px solid #B8C4D8; width: 0; height: 0; position:absolute; left:50%; bottom:-8px; margin-left:-4px;"></div></div>',
        
        linkToTarget: function(elem, style){
            
            if (typeof style == 'undefined') var style = {};
            var data_target = elem.data('target');
            var target = $("*[data-fedit='"+data_target+"']");
            
            if (target.size() > 0) {
                
                var target_pos = target.offset();
                var target_size = [ target.width(), target.height() ];
                
                $.extend(style,{left: Math.round(target_pos.left) + 'px'});
                
                elem.css(style);
                
            }
            
        },
        
        editorOpen: function(e,l){
            
            e.preventDefault();
            
            var fedit_icon = $(e.target);
            var data_target = fedit_icon.data('target');
            var target = $("*[data-fedit='"+data_target+"']");
            
            if (target.size() > 0) {
                
                var target_html = $.trim(target.html());
                var target_pos = target.offset();
                var target_size = [ target.width(), target.height() ];
                
                var popup_width = target_html.length < 25 ? 300 : 500;
                var textarea_height = target_html.length < 25 ? 16 : (target_html.length < 300 ? 100 : 200);
                var scroll_top = $(window).scrollTop();
                
                $('textarea',frontendEditor)
                .css({
                    height: textarea_height + 'px'
                });
                
                var pp_height = $('#frontendEditor').height();
                var pp_left = popup_width > target_size[0] ? target_pos.left - ((popup_width - target_size[0]) / 2) : target_pos.left;
                var pp_top = target_pos.top - pp_height - 30;
                
                if(pp_height > target_pos.top - scroll_top){
                    pp_top = target_pos.top + target_size[1] + 20;
                    $('.caret2','#frontendEditor').hide();
                    $('.caret1','#frontendEditor').show();
                }else{
                    $('.caret2','#frontendEditor').show();
                    $('.caret1','#frontendEditor').hide();
                }
                
                $('#frontendEditor')
                .css({
                    width: popup_width + 'px',
                    left: pp_left + 'px',
                    top: pp_top + 'px',
                    display: 'block',
                    opacity: 0
                })
                .data('fieldname',data_target)
                .animate({
                    opacity: 1
                });
                
                $('button','#frontendEditor').removeAttr('disabled').css({"background-color":"#E6EAF2"});
                
                $('textarea',frontendEditor)
                .val(target_html)
                .focus();
                
                //console.log(fedit_icon, target.text(), target_pos, target_size);
                
                
            }
            
        },
        
        editorInit: function(lang){
            
            $('body').append($.FrontendSimpleEdit.editorTemplate);
            
            $('#frontendEditor')
            .find('textarea')
            .bind('blur', function(){
                clearTimeout($.FrontendSimpleEdit.timer);
                $.FrontendSimpleEdit.timer = setTimeout(function(){
                    $('#frontendEditor').fadeOut();
                }, 1000);
            })
            .bind('focus', function(){
                clearTimeout($.FrontendSimpleEdit.timer);
            });
            
            $('button','#frontendEditor')
            .text($.FrontendSimpleEdit.lang_lexicon[$.FrontendSimpleEdit.opts.lang].button_save)
            .bind('click',function(e){
                
                e.preventDefault();
                
                var new_value = $('textarea','#frontendEditor').val();
                var fieldname = $('#frontendEditor').data('fieldname');
                var target = $("*[data-fedit='"+fieldname+"']");
                
                if (target.size() > 0) {
                    
                    clearTimeout($.FrontendSimpleEdit.timer);
                    $('button','#frontendEditor').prop('disabled','disabled').css({"background-color":"#ddd"});
                    
                    var post_data = {
                        action: "update",//"updatefromgrid",
                        HTTP_MODAUTH: $.FrontendSimpleEdit.opts.HTTP_MODAUTH,
                        id: $.FrontendSimpleEdit.opts.object_id,
                        context_key: $.FrontendSimpleEdit.opts.context_key
                    };
                    
                    post_data[fieldname] = new_value;
                    
                    $.ajax({
                        type: "POST",
                        cache: false,
                        dataType: 'json',
                        url: $.FrontendSimpleEdit.action_url,
                        data: post_data,
                        success: function(result){
                            
                            if (!result.success) {
                                if (!result.message || result.message.length == 0) {
                                    result.message = !!result.data && !!result.data[0].msg ? result.data[0].msg : 'error';
                                }
                                alert(result.message);
                            }else{
                                target.html(new_value);
                            }
                            
                            $('#frontendEditor').fadeOut();
                            
                        },error: function(jqXHR, textStatus, errorThrown){
                            //if(typeof(console)!='undefined') console.log(textStatus+' '+errorThrown);
                            alert(textStatus + ' ' + jqXHR.status + ' - ' + errorThrown);
                        }
                    });
                    
                }
                
                //alert(fieldname);
                
            });
            
        },
        
        onWindowResize: function(){
            
            $('a.fedit-icon').each(function(){
                $.FrontendSimpleEdit.linkToTarget($(this));
            });
            
        }
        
    }
    
    $.fn.FrontendSimpleEdit = function( options ) {
        
        var settings = $.extend({},{
            url: '',
            lang: 'ru',
            object_id: 0,
            context_key: 'web',
            HTTP_MODAUTH: ''
        }, options );
        
        $(window).bind('resize',$.FrontendSimpleEdit.onWindowResize);
        
        $.FrontendSimpleEdit.action_url = settings.url;
        
        if(!!$.FrontendSimpleEdit.lang_lexicon[settings.lang]) $.FrontendSimpleEdit.opts.lang = settings.lang;
        $.FrontendSimpleEdit.opts.object_id = settings.object_id;
        $.FrontendSimpleEdit.opts.context_key = settings.context_key;
        $.FrontendSimpleEdit.opts.HTTP_MODAUTH = settings.HTTP_MODAUTH;
        
        $.FrontendSimpleEdit.editorInit();
        
        return this.each(function() {
            
            var target_pos = $(this).offset();
            var target_fieldname = $(this).data('fedit');
            
            $('body').append('<a class="fedit-icon" href="#" title="' + $.FrontendSimpleEdit.lang_lexicon[$.FrontendSimpleEdit.opts.lang].edit_hint + '">' + $.FrontendSimpleEdit.lang_lexicon[$.FrontendSimpleEdit.opts.lang].edit_label + '</a>');
            var fedit_icon = $('a.fedit-icon:last','body');
            
            fedit_icon
            .data('target',target_fieldname)
            .bind('click',$.FrontendSimpleEdit.editorOpen);
            
            $.FrontendSimpleEdit.linkToTarget(fedit_icon, {
                position: 'absolute',
                left: target_pos.left+'px',
                top: (target_pos.top - 15)+'px',
                color: 'red'
            });
            
        });
        
    };

}( jQuery ));
